/*
  ᢮

     lincross.txt
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <values.h>

#define MAX_STR 128 /* ᨬ ࠧ ப */
#define MAX_WORDS 50 /* ᨬ쭮 ᫮ ᫮ */

char s[MAX_STR][MAX_WORDS], // ᢮ठ
     Buf[MAX_STR*MAX_WORDS]; //  ᫮ ᫮
int Len, //⢮ ᫮
    CrossLen=MAXINT, //쭠  ᢮ठ
    Cr[MAX_WORDS], //冷 ᫮  쭮 ᢮थ
    N[MAX_STR]; // ᫮ 1,2,...,Len
unsigned long A[MAX_STR]; //᫮ 宦  ᫮  N

void Error (int Code) { //饭  訡  襭 ࠡ
 char *Msg[]={
  "",
  "Linear cross-word. Give me file name as parameter",
  "File open error",
  "Can't read string from this file",
  "Too many words! Increase the value MAX_WORDS in program",
  "No memory"
 };
 cprintf ("\r\n Returned: %d:\r\n %s!\r\n Press ENTER...",
  Code,Msg[Code]);
 fflush (stdin); getch(); fcloseall();
 window (1,1,80,25); clrscr();
 exit (Code);
}

////////////   㭪権 ࠡ  䠩
FILE *Open(char *Name, char *Mode) { //⨥ 䠩
 FILE *f;
 f=fopen (Name,Mode);
 if (f==NULL) Error (2);
 return f;
}

int Close (FILE *f) { //⨥ 䠩
 return (fclose (f));
}

char *ReadStr (FILE *f, char *Str) { //⥭ ப  䠩
 char *Ptr=fgets (Str,MAX_STR,f);
 int l=strlen(Str)-1;
 while ((Str[l]=='\n') || (Str[l]=='\r')) Str[l--]='\0';
 return Ptr;
}
////////////    㭪権 ࠡ  䠩

int CrossPos (char *s1,char *s2) {
 //୥   s1, 稭  ன   稭 ப s2
 //᫨ s2  稭  s1, ୥  s1
 char *Ptr, *Ptr1, *Ptr2;
 int l1=strlen(s1);
 Ptr1=strrchr (s1,s2[0]);
 if (Ptr1) {
  Ptr=Ptr1; Ptr2=s2;
  while (*Ptr1==*Ptr2) {
   Ptr1++; Ptr2++;
   if (*Ptr1=='\0') return Ptr-s1;
  }
  return l1;
 }
 else return l1;
}

int StrLen (int *num) {
 //⠥ 㬬   ᢮ठ s
 int i,l;
 strcpy (Buf,s[num[0]-1]);
 for (i=1; i<Len; i++) {
  l=CrossPos(Buf,s[num[i]-1]);
  Buf[l]='\0';
  strcat (Buf,s[num[i]-1]);
 }
 return (strlen(Buf));
}

unsigned long Factorial (int n) { //ਠ ᫠ n
 if (n<2) return 1;
 else return (n*Factorial(n-1));
}

void Cross (void) {
 // ᢮  ᨢ s  Len ᫮
 // ,   LEN 
 //  LEN        ,
 //   
 int i,j,imin,jmin,b,min;
 unsigned long nf1=Factorial(Len-1);
  // Len ᥫ 稭 (Len-1)! 뢠, ᪮쪮 ࠧ 
  //       ⠭
 do {
  j=StrLen(N); //⠥   ⥪饣 ᢮ठ
  if (j<CrossLen) { //᫨    ࠭,
   CrossLen=j;      //䨪㥬   
   for (i=0; i<Len; i++) Cr[i]=N[i]; // ᫥⥫쭮 ᫮
  }

  //⫠筠 :
  cprintf ("\r\n%s",Buf);

  for (i=1,min=A[0],imin=0; i<Len; i++) if (A[i]<min) {
   min=A[i]; imin=i; //饬    ᫮ 宦
  }
  for (i=0,min=MAXINT; i<Len; i++) if (A[i]<min) if (i!=imin) {
   min=A[i]; jmin=i; //... ன  ⮬ ਧ
  }
  A[imin]++; A[jmin]++; //稢  ࠬ ᫮ 宦
  b=N[imin]; N[imin]=N[jmin]; N[jmin]=b; //塞  ⠬
  for (i=0,j=0; i<Len; i++) if (A[i]<=nf1) { j=1; break; }
   //᫨     ,  訬 祬 (Len-1)!
   //᫮ 宦, 室  ࠭
  if (j==0) break;
 } while (1);

}

int main (int argc, char *argv[]) {
 FILE *f; int i;

 if (argc>1) {
  if ((argv[1][0]=='/') || (argv[1][0]=='?')) Error (1);
  else f=Open(argv[1],"rt");
 }
 else Error (1);
 Len=0;
 while (!feof(f)) {
  ReadStr (f,&s[Len][0]);
  Len++;
  if (Len==MAX_WORDS) Error (4);
 }
 fclose (f);

 for (i=0; i<Len; i++) {
  N[i]=i+1; // ᫮
  A[i]=1;   //᫮ 宦
 }
 Cross ();

 f=Open("lincross.txt","wt");
 StrLen (Cr);
 fputs (Buf,f);
 fclose (f);

 cprintf ("\r\n   䠩 lincross.txt!");
 fflush (stdin); getch();
 Error (0);
 return 0;
}
