//debug!
/* ⠢ ணࠬ,  ᯮ 㭪樨
ࠡ  ⥪  ॢ 䬥᪨ ࠦ
몠     .
*/
#include <stdio.h>
#include <stdlib.h> /* extern double atof();            */
#include <math.h>   /* extern double sin(),  ...        */
#include <ctype.h>  /* isdigit(), isalpha(), ...        */
#include <setjmp.h> /* jmp_buf                          */

jmp_buf AGAIN;             /* ஫쭠 窠 */

 err(n) { longjmp(AGAIN,n); } /* 룭  ஫  */
    /*  --------------------------------------- */
    /* ᫨  饭 ࠭  ⥪ stk[] 
     *  ࠭,   믮 権 
     * ⥪   樨,  稬 ""
     *  ࠦ:
     *      a+b       ->      a b +
     *      (a+b)*c   ->      a b + c *
     *      a + b*c   ->      a b c * +
     */
    /* ⥪ ᫥ */
    #define MAXDEPTH 20 /* 㡨 ⥪ */
    int sp;             /* 㪠⥫ ⥪ (stack pointer) */
    double stk[MAXDEPTH];
    double dpush(d) double d; /*  ᫮  ⥪ */
    {
       if( sp == MAXDEPTH ){ printf("⥪ ࠭ \n");err(1);}
       else return( stk[sp++] = d );
    }
    double dpop(){            /*  設 ⥪ */
       if( !sp ){ printf("⥪ ࠭ \n"); err(2); }
       else return stk[--sp];
    }
    static double r,p; /* ᯮ⥫ ॣ */
    void add()    { dpush( dpop() + dpop()); }
    void mult()   { dpush( dpop() * dpop()); }
    void sub()    { r = dpop(); dpush( dpop() - r); }
    void divide() { r = dpop();
      if(r == 0.0){ printf("  0\n"); err(3); }
      dpush( dpop() / r );
    }
    void pwr() { r = dpop(); dpush( pow( dpop(), r )); }
    void dup() { dpush( dpush( dpop())); }
    void xchg(){ r = dpop(); p = dpop(); dpush(r); dpush(p); }
    void neg() { dpush( - dpop()); }
    void dsin(){ dpush( sin( dpop())); }
    void dcos(){ dpush( cos( dpop())); }
    void dexp(){ dpush( exp( dpop())); }
    void dlog(){ dpush( log( dpop())); }
    void dsqrt(){ dpush( sqrt( dpop())); }
    void dsqr(){ dup(); mult(); }
    /* M_PI  M_E ।  <math.h> */
    void pi()  { dpush( M_PI /* ᫮  */ ); }
    void e()   { dpush( M_E  /* ᫮ e  */ ); }
    void prn() { printf("%g\n", dpush( dpop())); }
    void printstk(){
      if( !sp ){ printf("⥪ ࠭ \n"); err(4);}
      while(sp) printf("%g ", dpop());
      putchar('\n');
    }
    /*  ---------------------------------------- */
    /*  ᥬ */
    #define END        (-3)         /* = */
    #define NUMBER     (-2)         /* ᫮ */
    #define BOTTOM      0           /* ᥢᥬ " ⥪" */
    #define OPENBRACKET   1         /* (  */
    #define FUNC          2         /* f( */
    #define CLOSEBRACKET  3         /* )  */
    #define COMMA         4         /* ,  */
    #define PLUS          5         /* +  */
    #define MINUS         6         /* -  */
    #define MULT          7         /* *  */
    #define DIV           8         /* /  */
    #define POWER         9         /* ** */
    /* ਮ */
    #define NOTDEF    333   /*  । */
    #define INFINITY 3000   /* ᪮筮 */
    /* ⥪ ࠭ */
    typedef struct _opstack {
            int cop;        /*  樨 */
            void (*f)();    /* "⫮" ⢨ */
    } opstack;
    int osp;        /* operations stack pointer */
    opstack ost[MAXDEPTH];
    void push(n, func) void (*func)();
    {
       if(osp == MAXDEPTH){ printf("⥪ 権 \n");err(5);}
       ost[osp].cop = n;  ost[osp++].f = func;
    }
    int pop(){
       if( !osp ){ printf("⥪ 権 \n"); err(6); }
       return ost[--osp].cop;
    }
    int top(){
       if( !osp ){ printf("⥪ 権 \n"); err(7); }
       return ost[osp-1].cop;
    }
    void (*topf())(){
       return ost[osp-1].f;
    }
    #define drop()          (void)pop()
    void nop(){ printf( "???\n" ); } /* no operation */
    void obr_err(){ printf( " 墠⠥ )\n" ); err(8); }
    /*  ਮ⮢ */
    struct synt{
            int inp_prt;    /* 室 ਮ     */
            int stk_prt;    /* ⥪ ਮ    */
            void (*op)();   /* ⢨  ⥪ ᫥ */
    } ops[] = {
      /* BOTTOM       */  {NOTDEF,   -1,     nop    },
      /* OPENBRACKET  */  {INFINITY,  0,     obr_err},
      /* FUNC         */  {INFINITY,  0,     obr_err},
      /* CLOSEBRACKET */  {1,        NOTDEF, nop    },  /* NOPUSH */
      /* COMMA        */  {1,        NOTDEF, nop    },  /* NOPUSH */
      /* PLUS         */  {1,         1,     add    },
      /* MINUS        */  {1,         1,     sub    },
      /* MULT         */  {2,         2,     mult   },
      /* DIV          */  {2,         2,     divide },
      /* POWER        */  {3,         3,     pwr    }
    };
    #define stkprt(i)    ops[i].stk_prt
    #define inpprt(i)    ops[i].inp_prt
    #define perform(i) (*ops[i].op)()
    /* 祭, 塞 ᪨ ஬ */
    double value; void (*fvalue)();
    int tprev;  /* । ᥬ */
    /* ࠭    +  */
    void reset(){ sp = osp = 0; push(BOTTOM, NULL); tprev = END;}
    void calc(){
      int t;
      do{
            if( setjmp(AGAIN))
                    printf( "⥪ ᫥ 訡 襭\n" );
            reset();
            while((t = token()) != EOF && t != END){
                    if(t == NUMBER){
                            if(tprev == NUMBER){
                                 printf("%g: ᫠ \n",value);
                                 err(9);
                            }
                            /*  ᫮    ⥪ */
                            tprev = t; dpush(value); continue;
                    }
                    /*  -  */
                    tprev = t;
            /* ⠫  믮 権  ⥪ */
                    while(inpprt(t) <= stkprt( top()) )
                            perform( pop());
            /* 饭   ᪮ */
                    if(t == CLOSEBRACKET){
                            if( top() == OPENBRACKET || top() == FUNC ){
                                    void (*ff)() = topf();
                                    drop(); /* 嫮 ᪮ */
                                    /* ࠡ⪠ 㭪樨 */
                                    if(ff)        (*ff)();
                            }else{ printf( " 墠⠥ (\n"); err(10); }
                    }
            /* ᥭ 権  ⥪ (஬ NOPUSH-権) */
                    if(t != CLOSEBRACKET && t != COMMA)
                            push(t,   t == FUNC ? fvalue : NULL );
            }
            if( t != EOF ){
              /* 믮 ⠢訥 樨 */
                while( top() != BOTTOM )
                    perform( pop());
                printstk();     /*  ⥪ ᫥ (⢥) */
            }
      } while (t != EOF);
    }
    /* ᪨  ---------------------------- */
    extern void getn(), getid(), getbrack();
    int token(){    /*  ᥬ */
            int c;
            while((c = getchar())!= EOF && (isspace(c) || c == '\n'));
            if(c == EOF) return EOF;
            ungetc(c, stdin);
            if(isdigit(c)){  getn(); return NUMBER; }
            if(isalpha(c)){ getid(); getbrack(); return FUNC; }
            return getop();
    }
    /*  ᫮ ( 窮) */
    void getn(){
            int c, i;  char s[80];
            s[0] = getchar();
            for(i=1; isdigit(c = getchar()); i++ )  s[i] = c;
            if(c == '.'){   /* ஡  */
               s[i] = c;
               for(i++; isdigit(c = getchar()); i++)  s[i] = c;
            }
            s[i] = '\0'; ungetc(c, stdin); value = atof(s);
    }
    /*   */
    int getop(){
            int c;
            switch( c = getchar()){
            case EOF:       return EOF;
            case '=':       return END;
            case '+':       return PLUS;
            case '-':       return MINUS;
            case '/':       return DIV;
            case '*':       c = getchar();
                            if(c == '*') return POWER;
                            else{ ungetc(c, stdin); return MULT; }
            case '(':       return OPENBRACKET;
            case ')':       return CLOSEBRACKET;
            case ',':       return COMMA;
            default:        printf( "訡筠  %c\n", c);
                            return token();
            }
    }
    struct funcs{   /*   㭪権 */
            char *fname; void (*fcall)();
    } tbl[] = {
            { "sin", dsin }, { "cos",   dcos  },
            { "exp", dexp }, { "sqrt",  dsqrt },
            { "sqr", dsqr }, { "pi",    pi    },
            { "sum", add  }, { "ln",    dlog  },
            { "e",   e    }, { NULL,    NULL  }
    };
    char *lastf;    /*   㭪樨 */
    /*   㭪樨 */
    void getid(){
            struct funcs *ptr = tbl;
            char name[80]; int c, i;
            *name = getchar();
            for(i=1; isalpha(c = getchar()); i++) name[i] = c;
            name[i] = '\0'; ungetc(c, stdin);
            /*   ⠡ */
            for( ; ptr->fname; ptr++ )
                    if( !strcmp(ptr->fname, name)){
                            fvalue = ptr->fcall;
                            lastf =  ptr->fname; return;
                    }
            printf( "㭪 \"%s\" ⭠\n", name ); err(11);
    }
    /*  뢠 ᪮ ᫥  㭪樨 */
    void getbrack(){
      int c;
      while((c = getchar()) != EOF && c != '(' )
      if( !isspace(c) && c != '\n' ){
          printf("  㭪樨 %s  ( ᨬ %c\n", lastf, c);
          ungetc(c, stdin); err(12);
      }
    }
    void main(){ calc();}
    /* ਬ:
            ( sin( pi() / 4 + 0.1 ) + sum(2, 4 + 1)) * (5 - 4/2) =
                    ⢥: 23.3225
            (14 + 2 ** 3 * 7 + 2 * cos(0)) / ( 7 - 4 ) =
                    ⢥: 24
    */

