/*
10.  ⭮  m x m  ⢮ -
஢ ⥩,    㫥. ᥤ -
 㫨, ᬥ  ⨪, ਧ⠫    -
 (3 ).
*/
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>

#define MAX_SIZE 100 /* ᨬ ࠧ  */
#define M 0 /* ,  饬 */
int a[MAX_SIZE][MAX_SIZE], //室 
    b[MAX_SIZE][MAX_SIZE]; //, 室  ᪠

void Error (int Code) {
 char *Msg[]={
  "OK",
  "Get me a filename as parameter",
  "Can't open this file",
  "Read error",
  "This file does not contain an integer matrix (number of rows,number of columns,items)",
  "Bad matrix size in this file",
  "Can't allocate a memory - decrease the value MAX_SIZE in the program"
 };
 printf ("\n %s!\n Press a key...",Msg[Code]);
 fflush (stdin); getchar();
 exit (Code);
}

void ReadIntMatrix (FILE *f, int *Rows, int *Cols, int MaxSize) {
 //⥭   䠩 f
 // a । 쭮!
 int i,j;
 fscanf (f,"%d",Rows);
 fscanf (f,"%d",Cols);
 if ( (*Rows<2) || (*Rows>MaxSize) || (*Cols<2) || (*Cols>MaxSize)) Error (5);
 for (i=0; i<*Rows; i++)
 for (j=0; j<*Cols; j++) fscanf (f,"%d",&a[i][j]);
}

void PrintIntMatrix (FILE *f, int Rows, int Cols) {
 //   䠩 f
 // a । 쭮!
 int i,j;
 for (i=0; i<Rows; i++) {
  for (j=0; j<Cols; j++) fprintf (f,"%d ",a[i][j]);
  fprintf (f,"\n");
 }
}

int IsArea (int i,int j,int m) {
 //஢,   冷 㦥 饩   㫥 
 //頥  
 if ( (i>0) && (b[i-1][j]!=0) ) return b[i-1][j];
 if ( (i<m-1) && (b[i+1][j]!=0) ) return b[i+1][j];
 if ( (j>0) && (b[i][j-1]!=0) ) return b[i][j-1];
 if ( (j<m-1) && (b[i][j+1]!=0) ) return b[i][j+1];
 if ( (i>0) && (j>0) && (b[i-1][j-1]!=0) ) return b[i-1][j-1];
 if ( (i>0) && (j<m-1) && (b[i-1][j+1]!=0) ) return b[i-1][j+1];
 if ( (i<m-1) && (j>0) && (b[i+1][j-1]!=0) ) return b[i+1][j-1];
 if ( (i<m-1) && (j<m-1) && (b[i+1][j+1]!=0) ) return b[i+1][j+1];
 return 0;
}

int Area (int m) {
 //⢮ ஢ ⥩,   㫥
 // a,b । 묨!
 int r=0,i,j,k;
 for (i=0; i<m; i++) for (j=0; j<m; j++) b[i][j]=0;
  // b 㤥     a   㫥,
  // ன  ਭ
 for (i=0; i<m; i++) for (j=0; j<m; j++) {
  if (a[i][j]==M) { // । 
   if (b[i][j]==0) { //    ⭥ᥭ  
    k=IsArea(i,j,m); //  冷 饩 ?
    if (k) b[i][j]=k; // - 襬     b
    else
    b[i][j]=++r; // - 㢥稢 ᫮ ⥩
		      // 襬  
   }
  }
 }
 return r; // ᫮ ⥩
}

void main (int argc, char *argv[]) {
 FILE *f;
 int m,r;
 printf ("\n  ᫠ ⥩,   㫥");
 if (argc==2) {
  f=fopen (argv[1],"rt");
  if (f==NULL) Error (2);
  ReadIntMatrix (f,&m,&r,MAX_SIZE);
  fclose (f);
 }
 else Error (1);

 r=Area (m);

 f=fopen ("matr_obl.txt","wt");
 if (f==NULL) Error (2);
 PrintIntMatrix (f,m,m);
 fprintf (f,"\n %d ⥩,   㫥",r);
 fclose (f);
 printf ("\n See the MATR_OBL.TXT");
}